function Q = qf(A)

% qf(A) returns the Q factor of the thin QR decomposition of A.

% Surprisingly, the QR function of Matlab may yield negative
% elements on the diagonal of the R factor. 

% Author: PA Absil, 2005

[Q,R] = qr(A,0);

diagR = diag(R);
diagR(diagR==0) = 1;
Q = Q*(diag(sign(diagR)));
end